#------------------------- MODS MENU ---------------------------------------

   proc add_luc_menu {w} {

      global ::env

      # MODS
      set which_instrument $env(INSTR)
      switch -exact -- $which_instrument  {
          MODS { set m [$w add_menubutton "MODS"] }
          default  {puts stdout "Warning: $which_instrument" }
      }


      # add the menus
      # index = 0: creates a mask
      $w add_menuitem $m command "Init Mask" {Create a MOS mask} -state normal -command [code f_on $w $m]

      # index = 1: deletes all slits
      $w add_menuitem $m command "Reset Mode" {Reset the current MOS mask } \
           -state disabled -command { catch {::mos::MOS::my_mask reset_mask} }

      # index =  2: loads a mask
      $w add_menuitem $m command "Load SetUp" {Load Mask from TAF}  \
           -state disabled -command { catch {::mos::MOS::my_mask load_TPX 0} }

      # index = 3: delets the mask
      $w add_menuitem $m command "Quit Mode" {Delete the current MOS mask } \
           -state disabled -command [code f_off $w $m]

      # index = 4
      $m add separator

      # index = 5: positions slits automatically (list required)
      $w add_menuitem $m command "Auto-Slit" {Compare target list with MOS slitlets}  \
           -state disabled -command { catch {::mos::MOS::my_mask AutoPos_new} }

      # index = 6: saves a mask
      $w add_menuitem $m command "Save SetUp" {Save the current MOS mask for OB processing} \
           -state disabled -command [code f_con_sav $m]

      # index = 7: handles reference stars
      $w add_menuitem $m cascade "Reference Targets" {Edit reference target list} \
           -state disabled -menu [menu $m.reftarg]

      # index = 8: handles guide stars
      $w add_menuitem $m cascade "Guide Stars" {Edit guide star list} \
           -state disabled -menu [menu $m.guidestar]

      # index = 9: displays status panel
      $w add_menuitem $m command "Status Panel" {Show Status Window}  \
           -command { catch {::mos::MOS::my_mask show_status} } -state disabled

      # index = 10
      $m add separator

      # index = 11: configuration menu
      $w add_menuitem $m cascade "Config / Layout" {Graphical Layout of the MODS mask}  \
           -state disabled -menu [menu $m.layout -tearoff 1]

      # --LAYOUT--
      #  l.0 = tearoff
      #  l.1
      $w add_menuitem $m.layout cascade "Slit Type" {Configure the slit type}  \
           -state disabled -menu [menu $m.layout.ls]
      #  l.2
      $w add_menuitem $m.layout cascade "Slit Width" {Configure the slit width} \
           -state disabled -menu [menu $m.layout.sw]
      #  l.3
      $w add_menuitem $m.layout cascade "Slit Length" {Configure the slit length}  \
           -state disabled -menu [menu $m.layout.sl]
      #  l.4
      $w add_menuitem $m.layout command "WaveLength Range" {Configure the wavelength range}  \
           -state  disabled -command { ::mos::MOS::my_mask wave_length  }
      #  l.5
      $w add_menuitem $m.layout cascade  "Camera" {Instrument SetUp: Camera}  \
           -state disabled -menu [menu $m.layout.sh]
      #  l.6
      $w add_menuitem $m.layout cascade "Band Filter" {Instrument SetUp : select Band Filter}  \
           -state disabled -menu [menu $m.layout.fi]
      #  l.7
      $w add_menuitem $m.layout cascade "Grating" {Instrument SetUp : select Grating}  \
           -state disabled -menu [menu $m.layout.gr]
      #  l.8
      $m.layout add separator

      #  l.9
      $w add_menuitem $m.layout cascade "Rotation Step" {Configure the mask rotation speed}  \
           -state disabled -menu [menu $m.layout.rs]
      #  l.10
      $w add_menuitem $m.layout cascade "Color" {Configure mask colour}  \
           -state disabled -menu [menu $m.layout.cs]
      #  l.11
      $w add_menuitem $m.layout checkbutton "Transparency" {Show positioned slit blades}  \
           -variable transp -onvalue 1 -offvalue 0 -state disabled \
           -command { catch {::mos::MOS::my_mask configure -graytype $transp} }
      #  l.12
      $w add_menuitem $m.layout checkbutton "Labels" {Label the mask}  \
           -variable su -onvalue 1 -offvalue 0 -state disabled \
           -command { catch {::mos::MOS::my_mask configure -label $su} }
      #  l.13
      $w add_menuitem $m.layout checkbutton "Center Slit" {Use PickObject to center MOS slit on target}  \
           -variable pisc -onvalue 1 -offvalue 0 -state disabled \
           -command { catch {::mos::MOS::my_mask configure -pics $pisc} }
      #  l.14
      $w add_menuitem $m.layout command "ProjectName" {File name to be saved : <mode>.<ec>.<ProjectName>.mms }  \
           -state  disabled -command { catch {::mos::MOS::my_mask select_filename } }
 

      # -- SUB-MENU LAYOUT -----------------------------------------------------------------------------------------------
      #  l.0 = tearoff widget
      # l.1
      foreach i {STRAIGHT CIRCLE} {
         $w add_menuitem $m.layout.ls radio "  $i ''" {Set Slit Type}  \
         -variable ls -value $i \
         -command {catch {::mos::MOS::my_mask configure -mos_shape $ls} }
      }

      # l.2
      foreach i {0.3 0.6 1.0 1.2 1.5 2.0 4.0} {
         $w add_menuitem $m.layout.sw radio "  $i ''" {Set Slit Width to $i}  \
         -variable sw -value $i \
         -command { catch {::mos::MOS::my_mask configure -slit_width $sw} }
      }

      # l.3
      foreach i {2.0 4.0 6.0 8.0 10.0 12.0 14.0 16.0 18.0 20.0} {
         $w add_menuitem $m.layout.sl radio "  $i ''" {Set Slit Length to $i} \
         -variable sl -value $i \
         -command {catch {::mos::MOS::my_mask configure -slit_length $sl} }
      }

      # l.4
      set cam_range {none none}
      foreach i $cam_range {
         $w add_menuitem $m.layout.sh radio "$i" {Setup Instrument : Select Camera}   \
         -variable cam -value $i \
         -command { catch {::mos::MOS::my_mask configure -camera $cam } }
      }

      # l.5
      set filt_range {none none} 
      foreach i $filt_range {
         $w add_menuitem $m.layout.fi radio "$i" {SetUp Instrument : Select OS Filter} \
         -variable fi -value $i  \
         -command { catch {::mos::MOS::my_mask configure -filter $fi } }
      }

      # l.6
      set grat_range {none none none none}
      foreach i $grat_range {
         $w add_menuitem $m.layout.gr radio "$i" {SetUp Instrument : Select Grating} \
         -variable gr -value $i  \
         -command { catch {::mos::MOS::my_mask configure -grating $gr } }
      }

      # l.7
      foreach i {0.05 0.1 0.3 1 2 5 10 15 45 90} {
         $w add_menuitem $m.layout.rs radio "  $i deg/click" {Set Rotation Speed to $i} \
         -variable rs -value $i  \
         -command { catch {::mos::MOS::my_mask configure -rotangle $rs}
                    catch {::mos::MOS::my_mask update_and_replot } }
      }

      # l.8
      foreach i {Red/Yellow  Green/Red Violet/Orange Black/White Gray Bright Dark} {
         $w add_menuitem $m.layout.cs radio "  $i" {Set color of mask to $i}  \
         -variable cs -value $i \
         -command {catch {::mos::MOS::my_mask configure -colorset $cs}
                   catch {::mos::MOS::my_mask update_and_replot} }
      }


      # RefTargs -- main menu index 7 ---------------------------------------------------------
      # ref.0
      $w add_menuitem $m.reftarg command "plot" {plot reference target list} \
           -command { catch {::mos::MOS::my_mask  edit_ref_targ plot} } -state normal

      # ref.1
      $w add_menuitem $m.reftarg command "show" {show reference target list} \
           -command { catch {::mos::MOS::my_mask  edit_ref_targ show} } -state normal

      # ref.2
      $w add_menuitem $m.reftarg command "add" {add reference targets to list} \
           -command { catch {::mos::MOS::my_mask edit_ref_targ add} } -state normal

      # ref.3
      $w add_menuitem $m.reftarg command "purge" {purge individual reference targets from list} \
           -command { catch {::mos::MOS::my_mask edit_ref_targ purge} } -state normal

      # ref.4
      $w add_menuitem $m.reftarg command "verify" {verify permitted positions of reference targets} \
           -command { catch {::mos::MOS::my_mask edit_ref_targ verify} } -state normal

      # ref.5
      $w add_menuitem $m.reftarg command "reset" {purge all reference targets in list} \
           -command { catch {::mos::MOS::my_mask edit_ref_targ reset} } -state normal

      # GuideStars -- main menu index 8 ---------------------------------------------------------
      # gui.0
      $w add_menuitem $m.guidestar command "plot" {plot guide star list} \
           -command {catch {::mos::MOS::my_mask edit_guide_star plot} } -state normal

      # gui.1
      $w add_menuitem $m.guidestar command "show" {show reference target list} \
           -command { catch {::mos::MOS::my_mask edit_guide_star show} } -state normal

      # gui.2
      $w add_menuitem $m.guidestar command "add" {add reference targets to list} \
           -command { catch {::mos::MOS::my_mask edit_guide_star add} } -state normal

      # gui.3
      $w add_menuitem $m.guidestar command "purge" {purge individual reference targets from list} \
           -command { catch {::mos::MOS::my_mask edit_guide_star purge} } -state normal

      # gui.4
      $w add_menuitem $m.guidestar command "verify" {verify permitted positions of reference targets} \
           -command { catch {::mos::MOS::my_mask edit_guide_star verify} } -state normal

      # gui.5
      $w add_menuitem $m.guidestar command "reset" {purge all reference targets in list} \
         -command { catch {::mos::MOS::my_mask edit_guide_star reset} } -state normal

   }

# ----------------------------------- END MENU -------------------------------------------------------------------
